/* edited on Tue Dec 21 15:35:16 1993 by steve comments below*/
/* Added extra features such as fruit ie pixmaps/bitmaps */
 
/* edited on Tue Aug 24 11:37:14 GMT 1993 by steve comments below*/
/* These are the primatives for drawing and menuing */
#include <stdio.h> 
#include <string.h>
#include <stdarg.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <Xm/Scale.h>
#include "jug_draw.h"
#define LAST_COL 15
#define NUM_OBJECTS 14

static XtAppContext app_context ;
static Widget top_level ;
static Widget main_window ;
static Widget drawing_area ;
static Widget menu_bar ;
static Display *p_disp ;
static int menu_item_altered=0 ; /* used to detect when something changed */
static char new_op = 'e' ;
static char try_pattern[300] ;
static int awoken ; /* used by the timer system */
static int new_value = 1;
static int clearing_objects = 1 ;
static int the_ball_size = 10 ;
static GC gc_array[LAST_COL+1] ;
static Pixel pix_array[LAST_COL+1] ;
static GC theGC ;
static GC blankGC ;
static Cardinal argcount ;
static Arg args[20] ;
static Pixmap back_pix=(Pixmap)NULL ;

typedef void (*P_FUNC)() ;
typedef char *P_CHAR ;
typedef Widget *P_WIDG ;

static Pixmap clown_pic=(Pixmap)NULL ;
static int clown_width ;
static int clown_height ;

static char col_array[LAST_COL+1][10] =
{
                "black", "blue", "green", "LightCyan", "red",
                "magenta", "brown", "pink", "grey37",
                "LightBlue", "sea green", "cyan", "salmon",
                "magenta", "yellow", "white" };

static struct object_type {
  int valid ;
  int width ;
  int height ;
  GC ob_gc ;
  Pixmap front_pic ;
  Pixmap back_pic ; 
  Pixmap mask ;
} objects[NUM_OBJECTS] ;

typedef struct {
  String left_mask ;
  String right_mask ;
  String left_pix ;
  String right_pix ;
  String mask1 ;
  String mask2 ;
  String mask3 ;
  String mask4 ;
  String mask5 ;
  String mask6 ;
  String mask7 ;
  String mask8 ;
  String mask9 ;
  String mask10 ;
  String mask11 ;
  String mask12 ;
  String pix1 ;
  String pix2 ;
  String pix3 ;
  String pix4 ;
  String pix5 ;
  String pix6 ;
  String pix7 ;
  String pix8 ;
  String pix9 ;
  String pix10 ;
  String pix11 ;
  String pix12 ;
  String black ;
  String dark_blue ;
  String green ;
  String cyan ;
  String red ;
  String magenta ;
  String brown ;
  String light_grey ;
  String dark_grey ;
  String light_blue ;
  String light_green ;
  String light_cyan ;
  String light_red ;
  String light_magenta ;
  String yellow ;
  String white ;
  } AppData, *AppDataPtr ;
static AppData data ;

static XtResource resources[] = {
  { "left_mask", "Left_mask", XmRString, sizeof(String),
    XtOffset(AppDataPtr, left_mask), XmRString, ""},
  { "right_mask", "Right_mask", XmRString, sizeof(String),
    XtOffset(AppDataPtr, right_mask), XmRString, ""},
  { "left_pix", "Left_pix", XmRString, sizeof(String),
    XtOffset(AppDataPtr, left_pix), XmRString, ""},
  { "right_pix", "Right_pix", XmRString, sizeof(String),
    XtOffset(AppDataPtr, right_pix), XmRString, ""},
  { "mask1", "Mask1", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask1), XmRString, ""},
  { "mask2", "Mask2", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask2), XmRString, ""},
  { "mask3", "Mask3", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask3), XmRString, ""},
  { "mask4", "Mask4", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask4), XmRString, ""},
  { "mask5", "Mask5", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask5), XmRString, ""},
  { "mask6", "Mask6", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask6), XmRString, ""},
  { "mask7", "Mask7", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask7), XmRString, ""},
  { "mask8", "Mask8", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask8), XmRString, ""},
  { "mask9", "Mask9", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask9), XmRString, ""},
  { "mask10", "Mask10", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask10), XmRString, ""},
  { "mask11", "Mask11", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask11), XmRString, ""},
  { "mask12", "Mask12", XmRString, sizeof(String),
    XtOffset(AppDataPtr, mask12), XmRString, ""},
  { "pix1", "Pix1", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix1), XmRString, ""},
  { "pix2", "Pix2", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix2), XmRString, ""},
  { "pix3", "Pix3", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix3), XmRString, ""},
  { "pix4", "Pix4", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix4), XmRString, ""},
  { "pix5", "Pix5", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix5), XmRString, ""},
  { "pix6", "Pix6", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix6), XmRString, ""},
  { "pix7", "Pix7", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix7), XmRString, ""},
  { "pix8", "Pix8", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix8), XmRString, ""},
  { "pix9", "Pix9", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix9), XmRString, ""},
  { "pix10", "Pix10", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix10), XmRString, ""},
  { "pix11", "Pix11", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix11), XmRString, ""},
  { "pix12", "Pix12", XmRString, sizeof(String),
    XtOffset(AppDataPtr, pix12), XmRString, ""},
  { "black", "Black", XmRString, sizeof(String),
  XtOffset(AppDataPtr, black), XmRString, ""},
  { "dark_blue", "Dark_blue", XmRString, sizeof(String),
  XtOffset(AppDataPtr, dark_blue), XmRString, ""},
  { "green", "Green", XmRString, sizeof(String),
  XtOffset(AppDataPtr, green), XmRString, ""},
  { "cyan", "Cyan", XmRString, sizeof(String),
  XtOffset(AppDataPtr, cyan), XmRString, ""},
  { "red", "Red", XmRString, sizeof(String),
  XtOffset(AppDataPtr, red), XmRString, ""},
  { "magenta", "Magenta", XmRString, sizeof(String),
  XtOffset(AppDataPtr, magenta), XmRString, ""},
  { "brown", "Brown", XmRString, sizeof(String),
  XtOffset(AppDataPtr, brown), XmRString, ""},
  { "light_grey", "Light_grey", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_grey), XmRString, ""},
  { "dark_grey", "Dark_grey", XmRString, sizeof(String),
  XtOffset(AppDataPtr, dark_grey), XmRString, ""},
  { "light_blue", "Light_blue", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_blue), XmRString, ""},
  { "light_green", "Light_green", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_green), XmRString, ""},
  { "light_cyan", "Light_cyan", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_cyan), XmRString, ""},
  { "light_red", "Light_red", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_red), XmRString, ""},
  { "light_magenta", "Light_magenta", XmRString, sizeof(String),
  XtOffset(AppDataPtr, light_magenta), XmRString, ""},
  { "yellow", "Yellow", XmRString, sizeof(String),
  XtOffset(AppDataPtr, yellow), XmRString, ""},
  { "white", "White", XmRString, sizeof(String),
  XtOffset(AppDataPtr, white), XmRString, ""}
  } ;

static XrmOptionDescRec options[] = {
    { "-left_mask", "*left_mask", XrmoptionSepArg, ""},
    { "-right_mask", "*right_mask", XrmoptionSepArg, ""},
    { "-left_pix", "*left_pix", XrmoptionSepArg, ""},
    { "-right_pix", "*right_pix", XrmoptionSepArg, ""},
    { "-mask1", "*mask1", XrmoptionSepArg, ""},
    { "-mask2", "*mask2", XrmoptionSepArg, ""},
    { "-mask3", "*mask3", XrmoptionSepArg, ""},
    { "-mask4", "*mask4", XrmoptionSepArg, ""},
    { "-mask5", "*mask5", XrmoptionSepArg, ""},
    { "-mask6", "*mask6", XrmoptionSepArg, ""},
    { "-mask7", "*mask7", XrmoptionSepArg, ""},
    { "-mask8", "*mask8", XrmoptionSepArg, ""},
    { "-mask9", "*mask9", XrmoptionSepArg, ""},
    { "-mask10", "*mask10", XrmoptionSepArg, ""},
    { "-mask11", "*mask11", XrmoptionSepArg, ""},
    { "-mask12", "*mask12", XrmoptionSepArg, ""},
    { "-pix1", "*pix1", XrmoptionSepArg, ""},
    { "-pix2", "*pix2", XrmoptionSepArg, ""},
    { "-pix3", "*pix3", XrmoptionSepArg, ""},
    { "-pix4", "*pix4", XrmoptionSepArg, ""},
    { "-pix5", "*pix5", XrmoptionSepArg, ""},
    { "-pix6", "*pix6", XrmoptionSepArg, ""},
    { "-pix7", "*pix7", XrmoptionSepArg, ""},
    { "-pix8", "*pix8", XrmoptionSepArg, ""},
    { "-pix9", "*pix9", XrmoptionSepArg, ""},
    { "-pix10", "*pix10", XrmoptionSepArg, ""},
    { "-pix11", "*pix11", XrmoptionSepArg, ""},
    { "-pix12", "*pix12", XrmoptionSepArg, ""},
    { "-black", "*black", XrmoptionSepArg, ""},
    { "-dark_blue", "*dark_blue", XrmoptionSepArg, ""},
    { "-green", "*green", XrmoptionSepArg, ""},
    { "-cyan", "*cyan", XrmoptionSepArg, ""},
    { "-red", "*red", XrmoptionSepArg, ""},
    { "-magenta", "*magenta", XrmoptionSepArg, ""},
    { "-brown", "*brown", XrmoptionSepArg, ""},
    { "-light_grey", "*light_grey", XrmoptionSepArg, ""},
    { "-dark_grey", "*dark_grey", XrmoptionSepArg, ""},
    { "-light_blue", "*light_blue", XrmoptionSepArg, ""},
    { "-light_green", "*light_green", XrmoptionSepArg, ""},
    { "-light_cyan", "*light_cyan", XrmoptionSepArg, ""},
    { "-light_red", "*light_red", XrmoptionSepArg, ""},
    { "-light_magenta", "*light_magenta", XrmoptionSepArg, ""},
    { "-yellow", "*yellow", XrmoptionSepArg, ""},
    { "-white", "*white", XrmoptionSepArg, ""}
  } ;


void manage_resize(void) ;

static void Load_colour(int neg_col_no, char *new_col) ;

static Pixmap process_xpm_mask(char *file_name, int *width, int *height) ;

static Pixmap make_pixmap(int p_width, int p_height) ;

static void Process_resources(void) ;

static void process_mask_and_pix(int ob_no, char *mask_name, char *pix_name) ;

static int get_int(char *a_line, char *delim) ;

static void do_ball_size(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data) ;

static void change_size(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data) ;

static void change_height(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data) ;

static void change_speed(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data) ;

static void height_scale(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data) ;

static void speed_scale(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data) ;

static void handle_resize(Widget w, caddr_t client_data,
XmDrawingAreaCallbackStruct *data) ;

static void change_op(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data) ;

static void change_pattern(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data) ;

static void attatch_to_cascade(Widget parent, char *label, Widget sub_menu) ;

static void add_push_buttons_to_menu(Widget parent, ...) ;

static Widget make_menu_pane(char *name, Widget parent, ...) ;

static void service_any_x_events(void) ;

static void setup_colours(void) ;

static void get_pixel_colour(Widget w, char *the_colour, Pixel *the_pix) ;

void start_X_window(int argc, char **argv)
{
  Dimension new_height ;

  Widget a_menu, sub_menu ;

  XtToolkitInitialize() ;
  app_context = XtCreateApplicationContext() ;
  p_disp =  XtOpenDisplay(app_context,
                          NULL, /* use display for environment */
                          NULL, /* use argv[0] as name */
                          "JUggle",
                          options, /* command line params */
                          XtNumber(options),
                          &argc,
                          argv) ; /* use standard options */
  if(p_disp == NULL)
  {
    perror("Unable to open display\n") ;
    exit(1) ;
  }
  XtSetArg(args[0], XmNtitle, "juggle") ;
  top_level = XtAppCreateShell(NULL, /* same as prog name */
                               "JUggle",
                               applicationShellWidgetClass,
                               p_disp,
                               args, 1) ;
  XtGetApplicationResources(top_level, &data, resources,
                            XtNumber(resources), NULL, 0) ;

  main_window = XmCreateMainWindow(top_level, "Main", NULL, 0) ;
  XtManageChild(main_window) ;

  argcount = 0 ;
  XtSetArg(args[argcount], XmNresizePolicy, XmRESIZE_ANY) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNtopAttachment, XmATTACH_FORM) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNrightAttachment, XmATTACH_FORM) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNbottomAttachment, XmATTACH_FORM) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_FORM) ;
  argcount++ ;
  drawing_area = XmCreateDrawingArea(main_window, "Drawing", args, argcount) ;
  XtManageChild(drawing_area) ;

  XtAddCallback(drawing_area, XmNresizeCallback, handle_resize,
      (caddr_t)drawing_area) ;
  XtAddCallback(drawing_area, XmNexposeCallback, handle_resize,
      (caddr_t)drawing_area) ;
  menu_bar = XmCreateMenuBar(main_window, "Menubar", NULL, 0) ;
  XtManageChild(menu_bar) ;

  a_menu = make_menu_pane("File_list", menu_bar,
             "Speed", speed_scale, NULL, 
             "Height", height_scale, NULL,
             "Ball size", do_ball_size, NULL,
             NULL) ;
  /*                 
  sub_menu = make_menu_pane("Speed", a_menu,
             "Slower", change_op, '4',
             "Faster", change_op, '6',
             NULL) ;
  attatch_to_cascade(a_menu, "Speed", sub_menu) ;

  sub_menu = make_menu_pane("height", a_menu,
             "Lower", change_op, '2',
             "Higher", change_op, '8',
             NULL) ;
  attatch_to_cascade(a_menu, "Height", sub_menu) ;
  */

  add_push_buttons_to_menu(a_menu ,
             "Default", change_op, 'd',
             "Mills mess", change_op, 'm',
             "Exit", change_op, 'e',
             NULL) ;


  attatch_to_cascade(menu_bar, "File", a_menu) ;

  a_menu = make_menu_pane("Pattern_list", menu_bar, NULL) ;
  sub_menu = make_menu_pane("3 balls", a_menu,
             "1", change_pattern, "3",
             "2", change_pattern, "612",
             "3", change_pattern, "522",
             "4", change_pattern, "504",
             "5", change_pattern, "531",
             "one hand", change_pattern, "60",
             NULL) ;
  attatch_to_cascade(a_menu, "3 Balls", sub_menu) ;

  sub_menu = make_menu_pane("4 balls", a_menu,
             "1a", change_pattern, "4",
             "1", change_pattern, "912",
             "2", change_pattern, "633",
             "3", change_pattern, "534",
             "4", change_pattern, "552",
             NULL) ;
  attatch_to_cascade(a_menu, "4 Balls", sub_menu) ;

  sub_menu = make_menu_pane("5 balls", a_menu,
             "1a", change_pattern, "5",
             "1", change_pattern, "744",
             "2", change_pattern, "609",
             "3", change_pattern, "753",
             "4", change_pattern, "94444",
             "5", change_pattern, "645",
             "6", change_pattern, "66661",
             "Flash", change_pattern, "55555555999990000",
             NULL) ;
  attatch_to_cascade(a_menu, "5 Balls", sub_menu) ;

  sub_menu = make_menu_pane("6 balls", a_menu,
             "1", change_pattern, "6",
             "2", change_pattern, "747",
             NULL) ;
  attatch_to_cascade(a_menu, "6 Balls", sub_menu) ;

  sub_menu = make_menu_pane("7 balls", a_menu,
             "1", change_pattern, "7",
             NULL) ;
  attatch_to_cascade(a_menu, "7 Balls", sub_menu) ;

  sub_menu = make_menu_pane("8 balls", a_menu,
             "1", change_pattern, "8",
             NULL) ;
  attatch_to_cascade(a_menu, "8 Balls", sub_menu) ;

  sub_menu = make_menu_pane("9 balls", a_menu,
             "1", change_pattern, "9",
             NULL) ;
  attatch_to_cascade(a_menu, "9 Balls", sub_menu) ;


  attatch_to_cascade(menu_bar, "Patterns", a_menu) ;

  XmMainWindowSetAreas(main_window, menu_bar, NULL, NULL, NULL,
      drawing_area) ;

  /* setup the colours now */
  Load_colour(0,data.black) ;
  Load_colour(-1,data.dark_blue) ;
  Load_colour(-2,data.green) ;
  Load_colour(-3,data.cyan) ;
  Load_colour(-4,data.red) ;
  Load_colour(-5,data.magenta) ;
  Load_colour(-6,data.brown) ;
  Load_colour(-7,data.light_grey) ;
  Load_colour(-8,data.dark_grey) ;
  Load_colour(-9,data.light_blue) ;
  Load_colour(-10,data.light_green) ;
  Load_colour(-11,data.light_cyan) ;
  Load_colour(-12,data.light_red) ;
  Load_colour(-13,data.light_magenta) ;
  Load_colour(-14,data.yellow) ;
  Load_colour(-15,data.white) ;
  setup_colours() ;

  /* popup the main window */
  XtRealizeWidget(top_level) ;

  XtSetArg(args[0], XmNheight, &new_height) ;
  XtGetValues(drawing_area, args, 1) ;
  do_the_resize(new_height-50) ;
  
  Process_resources() ;
  manage_resize() ;
}

void end_X_window(void) 
{
  XtCloseDisplay(p_disp) ;
}

void clear_main_window(void)
{
  XClearArea(p_disp, XtWindow(drawing_area), 0,0,0,0, False) ;
  manage_resize() ;
}

void wake_me_up(Widget w)
{
  awoken = 1 ;
  /* break the loop that is occuring below */
}

void pause_a_bit(long milisecs)
{
  awoken = 0 ;
  /* could use select here if you want */
  XtAppAddTimeOut(app_context, milisecs, wake_me_up, drawing_area) ;

  while(awoken == 0)
  {
    /* service any X type things and reduce our load on system */
    XtAppProcessEvent(app_context, XtIMAll) ;
  }
}

void set_the_colour(int col) 
{
  if(col == 0)
    clearing_objects = 1 ;
  else
    clearing_objects = 0 ;
  if((col < 16) &&(col > -1))
    XSetForeground(p_disp, theGC, pix_array[col]) ;
    /*theGC = gc_array[col] ;*/
  else
    printf("colour error %d\n", col) ;
}

void draw_circle(int x, int y, int item_no, int size)
{
  Pixel a_pix ;
  if(clearing_objects == 1)
  {
    XCopyArea(p_disp, back_pix, 
                      XtWindow(drawing_area), 
                      blankGC,
                      x,
                      y,
                      (unsigned)the_ball_size, 
                      (unsigned)the_ball_size,
                      x,
                      y) ;
  }
  else 
  {
    XSetForeground(p_disp, theGC, pix_array[item_no]) ;
    XFillArc(p_disp, XtWindow(drawing_area), theGC,
           x, y, size, size, 0, 360*64) ;
  }
}

void draw_object(int x, int y, int item_no)
{
  if(objects[item_no].valid == 0)
  {
    draw_circle(x, y, item_no, the_ball_size) ;
    return ;
  }

  XSetClipMask(p_disp, objects[item_no].ob_gc, objects[item_no].mask) ;
  XSetClipOrigin(p_disp, objects[item_no].ob_gc,
                         x-objects[item_no].width/2,
                         y-objects[item_no].height/2) ;
  if(clearing_objects == 1)
    XCopyArea(p_disp, back_pix, 
                      XtWindow(drawing_area), 
                      objects[item_no].ob_gc, 
                      x-objects[item_no].width/2,
                      y-objects[item_no].height/2,
                      (unsigned)objects[item_no].width, 
                      (unsigned)objects[item_no].height, 
                      x-objects[item_no].width/2,
                      y-objects[item_no].height/2) ;
  else
  {
    XCopyArea(p_disp, objects[item_no].front_pic, XtWindow(drawing_area), 
              objects[item_no].ob_gc, 0, 0, objects[item_no].width, 
              objects[item_no].height,
              x-objects[item_no].width/2,
              y-objects[item_no].height/2) ;

  }
}

void draw_line(int x1, int y1, int x2, int y2)
{
  if(clearing_objects == 1)
   XDrawLine(p_disp, XtWindow(drawing_area),
             blankGC, x1, y1, x2, y2) ;
  else
   XDrawLine(p_disp, XtWindow(drawing_area),
             theGC, x1, y1, x2, y2) ;
}

static void setup_colours(void) 
{
  Pixel a_pix ;
  int i, fg, bg ;
  XGCValues xgcv ;

  argcount = 0 ;
  XtSetArg(args[argcount], XmNforeground, &fg) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNbackground, &bg) ;
  argcount++ ;
  XtGetValues(drawing_area, args, argcount) ;

  xgcv.foreground = fg ;
  xgcv.background = bg ;
  theGC = XtGetGC(drawing_area, GCForeground | GCBackground, &xgcv) ;
  xgcv.foreground = bg ;
  xgcv.background = bg ;
  blankGC = XtGetGC(drawing_area, GCForeground | GCBackground, &xgcv) ;

  for(i=0; i<=LAST_COL; i++)
  {
    get_pixel_colour(drawing_area, col_array[i], &a_pix) ;
    xgcv.foreground = a_pix ;
    xgcv.background = bg ;
    gc_array[i] = XtGetGC(drawing_area, GCForeground | GCBackground, &xgcv) ;
    pix_array[i] = a_pix ;
  }
}

static void get_pixel_colour(Widget w, char *the_colour, Pixel *the_pix)
{
  XColor  colour ;
  Colormap col_map ;

  col_map = DefaultColormap(p_disp, DefaultScreen(p_disp)) ;

  if (XParseColor(p_disp, col_map, the_colour, &colour) == 0 ||
      XAllocColor(p_disp, col_map, &colour) == 0)
  {
    printf("juggle: Colour failure %s\n", the_colour) ;
    *the_pix = WhitePixel(p_disp, DefaultScreen(p_disp)) ;
  }
  else
  {
    *the_pix = colour.pixel ;
  }
}

void check_for_menu_op(int *changed, char *op, char *new_pattern)
{
  /* first service X events */
  service_any_x_events() ;
  
  *changed = 0 ;
  /* now check if anything has altered */
  /* if so return the information */
  if(menu_item_altered == 1)
  {
    *changed = new_value; /* used by speed and height */
    *op = new_op ;
    menu_item_altered = 0 ;
    if(new_op == 'n')
    {
      strcpy(new_pattern, try_pattern) ;
    }
  }
}

static void service_any_x_events(void)
{
  XEvent event ;

  while(XtAppPending(app_context) != 0)
  {
    XtAppNextEvent(app_context, &event) ;
    XtDispatchEvent(&event) ;
  }
}
static Widget make_menu_pane(char *name, Widget parent, ...)
{
  va_list       argp ;  /* used to access arguments */

  Widget        new_menu ;
  char          *item_label ;
  Widget        button ;
  P_FUNC        item_action ;
  caddr_t       action_args ;
  Arg           args[10] ;
  int           argcount ;
  unsigned long the_key ;

  new_menu = XmCreatePulldownMenu(parent, name, NULL, 0) ;

  /* we now add the push buttons to this new menu */

  va_start(argp, parent) ; /* get each item from vari args */

  while((item_label = va_arg(argp, P_CHAR)) != NULL)
  {

    item_action = va_arg(argp, P_FUNC) ;
    action_args = va_arg(argp, caddr_t) ;

    argcount = 0 ;
    XtSetArg(args[argcount],XmNborderWidth, 0) ;
    argcount++ ;
    if (strcmp(item_label, "SEP") == 0)
    {
      XtSetArg(args[argcount], XmNseparatorType,
          XmSHADOW_ETCHED_OUT) ;
      argcount++ ;
      button = XmCreateSeparator(new_menu, item_label,
          args, argcount) ;
    }
    else
    {
      button = XmCreatePushButton(new_menu, item_label,
          args, argcount) ;
      XtAddCallback(button, XmNactivateCallback,
          item_action, action_args) ;
    }
    XtManageChild(button) ;
  }
  va_end(argp) ;
  return(new_menu) ;
}

static void attatch_to_cascade(Widget parent, char *label, Widget sub_menu)
{
  Arg      args[10] ;
  Cardinal argcount ;
  Widget   cbutton ;

  /* Create the cascade button and attach sub menu to it */

  argcount = 0 ;
  XtSetArg(args[argcount], XmNsubMenuId, sub_menu) ;
  argcount++ ;
  XtSetArg(args[argcount],XmNshadowThickness, 4) ;
  argcount++ ;
  XtSetArg(args[argcount],XmNborderWidth, 0) ;
  argcount++ ;
  cbutton = XmCreateCascadeButton(parent, label,
      args, argcount) ;
  XtManageChild(cbutton) ;
}

static void speed_scale(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data)
{
  static Widget speed_dialog = (Widget)NULL ;

  Widget scale_widget ;

  if (speed_dialog == (Widget)NULL)
  {
    argcount = 0 ;
    XtSetArg(args[argcount], XmNdialogStyle, XmDIALOG_MODELESS) ;
    argcount++ ;
    speed_dialog = XmCreateBulletinBoardDialog(top_level,
        "Ball speed", args, argcount) ;

    argcount = 0 ;
    XtSetArg(args[argcount], XmNorientation, XmHORIZONTAL) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNvalue, 50) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNshowValue, True) ;
    argcount++ ;
    scale_widget = XmCreateScale(speed_dialog, "Speed", args, argcount) ;
    XtManageChild(scale_widget) ;
    XtAddCallback(scale_widget, XmNdragCallback, change_speed, NULL) ;
    XtAddCallback(scale_widget, XmNvalueChangedCallback, change_speed, NULL) ;
  }
  XtManageChild(speed_dialog) ;
}

static void change_speed(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data)
{
  static current_value=50 ;

  if(call_data->value < current_value)
    new_op = '6' ;
  if(call_data->value > current_value)
    new_op = '4' ;
  current_value = call_data->value ;
  new_value = current_value ;
  menu_item_altered = 1 ;
}

static void change_op(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data)
{
  new_op = (char )client_data ;
  menu_item_altered = 1 ;
}

static void change_pattern(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data)
{
  new_op = 'n' ;
  strcpy(try_pattern, (char *)client_data) ;
  menu_item_altered = 1 ;
}

static void add_push_buttons_to_menu(Widget parent, ...)
{
  va_list       argp ;  /* used to access arguments */

  Widget        new_list ;
  char          *item_label ;
  Widget        button ;
  P_FUNC        item_action ;
  caddr_t       action_args ;

  /* we now add the push buttons to this new menu */

  va_start(argp, parent) ; /* get each item from vari args */

  while((item_label = va_arg(argp, P_CHAR)) != NULL)
  {

    item_action = va_arg(argp, P_FUNC) ;
    action_args = va_arg(argp, caddr_t) ;
    argcount = 0 ;
    XtSetArg(args[argcount],XmNborderWidth, 0) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNshadowThickness, 2) ;
    argcount++ ;
    button = XmCreatePushButton(parent, item_label,
        args, argcount) ;

    XtAddCallback(button, XmNactivateCallback,
        item_action, action_args) ;
    XtManageChild(button) ;
  }
  va_end(argp) ;
} /* add_push_buttons_to_menu */

void manage_resize(void) 
{
  Dimension new_height ;
  Dimension new_width ;
  Pixel fg, bg ;
  int depth ;
  Window root_win ;

  XtSetArg(args[0], XmNheight, &new_height) ;
  XtSetArg(args[1], XmNwidth, &new_width) ;
  XtGetValues(drawing_area, args, 2) ;

  do_the_resize(new_height-50) ;
  if(back_pix != (Pixmap)NULL)
    XFreePixmap(p_disp, back_pix) ;
  depth = DefaultDepth(p_disp, DefaultScreen(p_disp)) ;
  root_win = RootWindow(p_disp, DefaultScreen(p_disp)) ;
  back_pix = XCreatePixmap(p_disp, root_win,
      (unsigned)new_width, (unsigned)new_height, depth) ;

  argcount = 0 ;
  XtSetArg(args[argcount], XmNforeground, &fg) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNbackground, &bg) ;
  argcount++ ;
  XtGetValues(drawing_area, args, argcount) ;
  XSetForeground(p_disp, theGC, bg) ;
  XFillRectangle(p_disp, back_pix, theGC, 0, 0,
                   new_width, new_height) ;
  if(clown_pic != (Pixmap)NULL)
  {
    XCopyArea(p_disp, clown_pic, 
                    XtWindow(drawing_area), 
                    blankGC, 0, 0,
                    (unsigned)clown_width, 
                    (unsigned)clown_height, 100, new_height-200) ;
    XCopyArea(p_disp, clown_pic, 
                    back_pix,
                    blankGC, 0, 0,
                    (unsigned)clown_width, 
                    (unsigned)clown_height, 100, new_height-200) ;
  }

}

static void handle_resize(Widget w, caddr_t client_data,
XmDrawingAreaCallbackStruct *data)
{
  manage_resize() ;
}

static void height_scale(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data)
{
  static Widget height_dialog = (Widget)NULL ;

  Widget scale_widget ;

  if (height_dialog == (Widget)NULL)
  {
    argcount = 0 ;
    XtSetArg(args[argcount], XmNdialogStyle, XmDIALOG_MODELESS) ;
    argcount++ ;
    height_dialog = XmCreateBulletinBoardDialog(top_level,
        "Ball height", args, argcount) ;

    argcount = 0 ;
    XtSetArg(args[argcount], XmNorientation, XmHORIZONTAL) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNvalue, 15) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNshowValue, True) ;
    argcount++ ;
    scale_widget = XmCreateScale(height_dialog, "Height", args, argcount) ;
    XtManageChild(scale_widget) ;
    XtAddCallback(scale_widget, XmNdragCallback, change_height, NULL) ;
    XtAddCallback(scale_widget, XmNvalueChangedCallback, change_height, NULL) ;
  }
  XtManageChild(height_dialog) ;
}

static void change_size(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data)
{
  the_ball_size = 10 + call_data->value/10 ;
}

static void change_height(Widget w, caddr_t client_data,
XmScaleCallbackStruct *call_data)
{
  static current_value=50 ;

  if(call_data->value < current_value)
    new_op = '8' ;
  if(call_data->value > current_value)
    new_op = '2' ;
  current_value = call_data->value ;
  new_value = current_value ;
  menu_item_altered = 1 ;
}

static Pixmap process_xpm_mask(char *file_name, int *width, int *height) 
{ 
  FILE *handle ;
  char *token, a_line[1000] ;
  int p_format, p_chars, p_ncols, i, j, k, len ;
  char delim[] = " \" } {, \n \t \r" ;
  char colour_items[256] ;
  Pixel colour_pixels[256] ;
  Pixel a_pix ;
  Pixmap a_pixmap ;
 
  handle = fopen(file_name, "rt") ;
  if(handle == NULL)
    return(NULL) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ;
  p_format = get_int(a_line, delim) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ;
  *width = get_int(a_line, delim) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ;
  *height = get_int(a_line, delim) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ;
  p_ncols = get_int(a_line, delim) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ;
  p_chars = get_int(a_line, delim) ;

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ; /* colors area */

  for(i=0; i<p_ncols; i++)
  {
    if(fgets(a_line, 1000, handle) == NULL)
      return(NULL) ;
    token = strtok(a_line, "\"") ;
    colour_items[i] = token[0] ;
    token = strtok(NULL, delim) ;
    get_pixel_colour(drawing_area, token, &a_pix) ;
    colour_pixels[i] = a_pix ;
  }
  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ; /* end colors area */

  if(fgets(a_line, 1000, handle) == NULL)
    return(NULL) ; /* pixels area */

  a_pixmap = make_pixmap(*width, *height) ;
  if(a_pixmap == (Pixmap)NULL)
    return(NULL) ;

  for(i=0; i<*height; i++)
  {
    if(fgets(a_line, 1000, handle) == NULL)
      return(NULL) ; 
    token = strtok(a_line, "\"") ;
    len = strlen(token) ;
    for(j=0; j<len; j++)
    {
      for(k=0; k<p_ncols; k++)
      {
        if(colour_items[k] == token[j])
        {
          a_pix = colour_pixels[k] ;
          break ;
        }
      }
      XSetForeground(p_disp, theGC, a_pix) ;
      XDrawPoint(p_disp, a_pixmap, theGC, j, i) ;
    } 
  }
  fclose(handle) ;
  return(a_pixmap) ;
}

static int get_int(char *a_line, char *delim)
{
  char *token ;
  token = strtok(a_line, delim) ;
  token = strtok(NULL, delim) ;
  token = strtok(NULL, delim) ;
  return(atoi(token)) ;
}

static Pixmap make_pixmap(int p_width, int p_height) 
{
  unsigned int depth ;
  Window root_win ;
  Pixmap a_pix ;
 
  depth = DefaultDepth(p_disp, DefaultScreen(p_disp)) ;
  root_win = RootWindow(p_disp, DefaultScreen(p_disp)) ;

  a_pix = XCreatePixmap(p_disp, root_win,
      (unsigned)p_width, (unsigned)p_height, depth) ;
  return(a_pix) ;
}

static void Process_resources(void) 
{
  int i ;

  /* make invalid first */
  for(i=0; i<NUM_OBJECTS; i++)
    objects[i].valid = 0 ;
  
  /*
  clown_pic = process_xpm_mask("/home/steve/juggle/juggler.xpm",&clown_width,
              &clown_height);
  */

  if((strlen(data.left_mask) > 0) && (strlen(data.left_pix)>0))
    process_mask_and_pix(12, data.left_mask, data.left_pix) ;

  if((strlen(data.right_mask) > 0) && (strlen(data.right_pix)>0))
    process_mask_and_pix(13, data.right_mask, data.right_pix) ;

  if((strlen(data.mask1) > 0) && (strlen(data.pix1)>0))
    process_mask_and_pix(0, data.mask1, data.pix1) ;

  if((strlen(data.mask2) > 0) && (strlen(data.pix2)>0))
    process_mask_and_pix(1, data.mask2, data.pix2) ;

  if((strlen(data.mask3) > 0) && (strlen(data.pix3)>0))
    process_mask_and_pix(2, data.mask3, data.pix3) ;

  if((strlen(data.mask4) > 0) && (strlen(data.pix4)>0))
    process_mask_and_pix(3, data.mask4, data.pix4) ;

  if((strlen(data.mask5) > 0) && (strlen(data.pix5)>0))
    process_mask_and_pix(4, data.mask5, data.pix5) ;

  if((strlen(data.mask6) > 0) && (strlen(data.pix6)>0))
    process_mask_and_pix(5, data.mask6, data.pix6) ;

  if((strlen(data.mask7) > 0) && (strlen(data.pix7)>0))
    process_mask_and_pix(6, data.mask7, data.pix7) ;

  if((strlen(data.mask8) > 0) && (strlen(data.pix8)>0))
    process_mask_and_pix(7, data.mask8, data.pix8) ;

  if((strlen(data.mask9) > 0) && (strlen(data.pix9)>0))
    process_mask_and_pix(8, data.mask9, data.pix9) ;

  if((strlen(data.mask10) > 0) && (strlen(data.pix10)>0))
    process_mask_and_pix(9, data.mask10, data.pix10) ;

  if((strlen(data.mask11) > 0) && (strlen(data.pix11)>0))
    process_mask_and_pix(10, data.mask11, data.pix11) ;

  if((strlen(data.mask12) > 0) && (strlen(data.pix12)>0))
    process_mask_and_pix(11, data.mask12, data.pix12) ;
}

static void process_mask_and_pix(int ob_no, char *mask_name, char *pix_name)
{
  int valid, width, height, x_hot, y_hot ;
  XGCValues xgcv ;
  Pixel fg, bg ;

  argcount = 0 ;
  XtSetArg(args[argcount], XmNforeground, &fg) ;
  argcount++ ;
  XtSetArg(args[argcount], XmNbackground, &bg) ;
  argcount++ ;
  XtGetValues(drawing_area, args, argcount) ;

  objects[ob_no].valid = XReadBitmapFile(p_disp, XtWindow(drawing_area),
                         mask_name, &objects[ob_no].width, 
                                    &objects[ob_no].height, 
                         &objects[ob_no].mask,&x_hot,&y_hot) ;
  if(objects[ob_no].valid == BitmapSuccess)
  {
    objects[ob_no].front_pic = process_xpm_mask(pix_name, &width, &height) ;
    objects[ob_no].ob_gc = XtGetGC(drawing_area, 0, &xgcv) ;
    XSetClipMask(p_disp, objects[ob_no].ob_gc, objects[ob_no].mask) ;
    objects[ob_no].back_pic = make_pixmap(width, height) ;
    XSetForeground(p_disp, theGC, bg) ;
    XFillRectangle(p_disp, objects[ob_no].back_pic, theGC, 0, 0,
                   width, height) ;
    objects[ob_no].valid = 1 ;
  }
  else
  {
    objects[ob_no].valid = 0 ; 
    printf("failed %s\n", mask_name) ;
  }
}

void right_hand_pic(int x1, int y1, int x2, int y2) 
{
  if(objects[12].valid == 1)
    draw_object(x2, y2, 12) ;
  else  
    line(x1, y1, x2, y2) ;
}
void left_hand_pic(int x1, int y1, int x2, int y2) 
{
  if(objects[13].valid == 1)
    draw_object(x1, y1, 13) ;
  else  
    line(x1, y1, x2, y2) ;
}

static void do_ball_size(Widget w, caddr_t client_data,
XmAnyCallbackStruct *call_data)
{
  static Widget ball_size_dialog = (Widget)NULL ;

  Widget scale_widget ;

  if (ball_size_dialog == (Widget)NULL)
  {
    argcount = 0 ;
    XtSetArg(args[argcount], XmNdialogStyle, XmDIALOG_MODELESS) ;
    argcount++ ;
    ball_size_dialog = XmCreateBulletinBoardDialog(top_level,
        "Ball size", args, argcount) ;

    argcount = 0 ;
    XtSetArg(args[argcount], XmNorientation, XmHORIZONTAL) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNvalue, 10) ;
    argcount++ ;
    XtSetArg(args[argcount], XmNshowValue, True) ;
    argcount++ ;
    scale_widget = XmCreateScale(ball_size_dialog, "Size", args, argcount) ;
    XtManageChild(scale_widget) ;
    XtAddCallback(scale_widget, XmNdragCallback, change_size, NULL) ;
    XtAddCallback(scale_widget, XmNvalueChangedCallback, change_size, NULL) ;
  }
  XtManageChild(ball_size_dialog) ;
}

static void Load_colour(int neg_col_no, char *new_col)
{
    /* we have a new colour to replace old one */
  if(strlen(new_col) > 0)
    strcpy(col_array[-neg_col_no], new_col) ;

}

