/* edited on Tue Dec 21 15:36:05 1993 by steve comments below*/
/* now uses hand pixmaps if available. */
 
/****************************************************************************
*           School of Electronic and Electrical Engineering                 *
*                  The Robert Gordon University                             *
*****************************************************************************
*                                                                           *
*           File name :JUGGLE.C                                              *
*           Author :Kendall Harrison                                        *
*           Date :25/1/93                                                  *
*           Class :PGDIP/MSc                                                *
*                                                                           *
*****************************************************************************
*                                                                           *
*   Description:A program to juggle any pattern on the screen,including     *
*               Mill's mess.(Press 'm' to switch between normal juggling    *
*               and Mill's mess)                                            *
*               Sorry the program is a bit of a mess,it could be            *
*               tidied up using structures,but I didn't know about them     *
*               when I wrote it!                                            *
*                                                                           *
*               Keys:                                                       *
*               e     Exit                                                  *
*               m     Switch to and from Mill's mess                        *
*               c     Cycle the pattern one place to the left               *
*               s     One beat per keypress ('a' for automatic)             *
*               d     Default values for height,speed,etc.                  *
*               4     Slow down                                             *
*               6     Speed up                                              *
*               8     Increase height                                       *
*               2     Decrease height                                       *
*                                                                           *
****************************************************************************/

/* **************************************************************************
*             Ported to X Window system and Motif By S.J.Limb 6.8.93        *
*                    Fruit added by S.J.Limb 8.12.93                        *
*             P.S. Don't ask me about the codes for patterns                *
*****************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "jug_draw.h"
         /* above has drawing primatives */

#define FRAMES 10
#define BALLSIZE 8
#define HANDWIDTH 20
#define JUG_RED 4


int base,sep;
/*int points[5]={200,270,280,290,360}; */
/* these points appear to be where the starts for drawing are */

int points[5]={100,170,180,190,260};
int h[8]={-30,30,-40,30,-30,30,20,-40};
int mills_mess[6*FRAMES+1][2];
int normal[6*FRAMES+1][2];
int hands_position=0;
int last_left_hand_x_pos=0,last_left_hand_y_pos=0;
int last_right_hand_x_pos=0,last_right_hand_y_pos=0;
int _3height,one_step,stop_juggling,restart,k;
int paths[4][10][8*FRAMES+1][2];
int number_of_balls,pattern_length;
int millsmess,pause,direction;
int p[4][4]={{0,0,0,0},{0,-3,1,0},{0,2,0,-2},{0,0,-1,3}};
int table[2][6]={{1,0,3,0,2,4},{4,2,0,3,4,1}};
int ball[9][6],old_ball[9][2];
char pattern[300];
int *movement;

void switch_on_graphics(int argc, char **argv);
void switch_off_graphics(void);
void prt_delay(void);
void prt_height(void);
void prt_pattern(void);
void headings(void);
void default_values(void);
void set_up(void);
int  *parabola(int x_start,int y,int x_end,int h,int n,int *pointer);
void calculate_trajectories(void);
void calc_hand_movements(void);
void move_hands_one_frame(int freeze_left,int freeze_right);
void move_balls_one_frame(void);
void check_keyboard(void);
int juggle(void);
void input(char *pattern);
int check(char *pattern);

/* new routines by S.J.Limb to remove the dependance upon Borland and PC's */

void cleardevice(void) ;

void clear_window(void) ;

void delay(long num) ;

void setcolor(int colour) ;

void line(int x1, int y1, int x2, int y2) ;

void do_the_juggling(void) ;

void switch_on_graphics(int argc, char **argv)
{
  start_X_window(argc, argv) ;
}

void switch_off_graphics(void)
{
  end_X_window() ;
}

void prt_delay(void)
{
  printf(pause==0 ? "Full speed       ":"Delay :%dms per frame\n",pause);
}

void prt_height(void)
{
  printf("Three height :%3d\n",_3height);
}

void prt_pattern(void)
{
  int c;

  for(c=0;(c<pattern_length) && (c<40);++c)
   printf("%d",pattern[c]);
  if(pattern_length>40)
    printf("...");
  printf("\n") ;
}

void headings(void)
{
  if(number_of_balls>0)
  {
    printf("%d ball",number_of_balls);
    if(number_of_balls!=1)
      printf("s\n");
    else
      printf("\n") ;
  }
  else
    printf("No balls");
  printf("Frames per beat :%d\n",FRAMES);
  printf("Pattern :");
  prt_delay();
  prt_height();
  prt_pattern();
}

void default_values(void)
{
  millsmess=0;
  one_step=0;
  pause=50;
  _3height=15;
  /*base=250; */
  /* this is setup as an extern from jug_draw.c */

  sep=40;
}

void set_up(void)
{
  default_values();
  printf("base = %d\n", base) ;
  /* print up images of balls  */
  printf("Calculating hand movements ...\n");
  calc_hand_movements();
  printf("Calculating trajectories ...\n");
  calculate_trajectories();
}

int  *parabola(int x_start,int y,int x_end,int h,int n,int *pointer)
 {
  float x_disp,y_disp;
  float factor,step,x;
  int count;

  factor=(4.0*h)/((x_end-x_start)*(x_end-x_start));
  step=((float)(x_end-x_start))/(n-1);
  x_disp=(x_end+x_start)/2.0;
  y_disp=(float)(y-h);
  *pointer=x_start;
  *(pointer+1)=y;
  pointer+=2;
  x=(float)x_start+step;

  for(count=0;count<n-2;++count)
  {
    *pointer=(int)x;
    *(pointer+1)=(int)(y_disp+factor*(x-x_disp)*(x-x_disp));
    pointer+=2;
    x+=step;
  }

  *pointer=x_end;
  *(pointer+1)=y;
  return(pointer);
 }


void calculate_trajectories(void)
 {
  int height,count,true_height,no_of_points;

  for(height=3;height<10;++height)
   {
    true_height=(int)(((height-1)/2.0)*((height-1)/2.0)*_3height);
    no_of_points=(height-1)*FRAMES+1;

    parabola(points[4]-sep,base-BALLSIZE,(height%2) ? points[0]:points[4],
             true_height,no_of_points,&paths[0][height][0][0]);

    parabola(points[0],base-BALLSIZE,points[1],true_height,no_of_points,
             &paths[1][height][0][0]);

    parabola(points[0],base-BALLSIZE,points[2],true_height,no_of_points,
             &paths[2][height][0][0]);

    parabola(points[0],base-BALLSIZE,points[3],true_height,no_of_points,
             &paths[3][height][0][0]);
   }

  parabola(points[4],base-BALLSIZE,points[0],1,FRAMES+1,&paths[0][1][0][0]);
  parabola(points[1],base-BALLSIZE,points[2],1,FRAMES+1,&paths[1][1][0][0]);
  parabola(points[2],base-BALLSIZE,points[1],1,FRAMES+1,&paths[2][1][0][0]);
  for(count=0;count<FRAMES+1;++count)
  {
    paths[3][1][count][0]=points[3];
    paths[3][1][count][1]=base-BALLSIZE;
  }
}

void calc_hand_movements(void)
{
  int *next,count;

  next=&mills_mess[0][0];
  for(count=0;count<6;++count)
   next=parabola(points[table[0][count]],base,points[table[0][(count+1)%6]],
		 h[count],FRAMES+1,next);

  next=&normal[0][0];
  for(count=0;count<3;++count)
  {
    next=parabola(points[4],base,points[4]-sep,h[7],FRAMES+1,next);
    next=parabola(points[4]-sep,base,points[4],h[6],FRAMES+1,next);
  }
}

void move_hands_one_frame(int freeze_left,int freeze_right)
{
  int x_right,y_right,x_left,y_left,index;

  freeze_left&=~millsmess;
	freeze_right&=~millsmess;
  hands_position=(hands_position+1)%(6*FRAMES);

  x_right=*(movement+hands_position*2);
  y_right=*(movement+hands_position*2+1);
  index=(hands_position+3*FRAMES)%(6*FRAMES);
  x_left=points[0]+points[4]-*(movement+index*2);
  y_left=*(movement+index*2+1);

  if(freeze_right && ((last_right_hand_x_pos!=points[4])||
     (last_right_hand_y_pos!=base)))
  {
    x_right=points[4];
    y_right=base;
    freeze_right=0;
  }
  if(!freeze_right)
  {
    setcolor(0);
    right_hand_pic(last_right_hand_x_pos-HANDWIDTH/2,last_right_hand_y_pos,
	 last_right_hand_x_pos+HANDWIDTH/2,last_right_hand_y_pos);
    setcolor(JUG_RED);
    right_hand_pic(x_right-HANDWIDTH/2,y_right,x_right+HANDWIDTH/2,y_right);

    last_right_hand_x_pos=x_right;
    last_right_hand_y_pos=y_right;
   }

  if(freeze_left && ((last_left_hand_x_pos!=points[0])||
     (last_left_hand_y_pos!=base)))
  {
    x_left=points[0];y_left=base;
    freeze_left=0;
  }
  if(!freeze_left)
  {
    setcolor(0);
    left_hand_pic(last_left_hand_x_pos-HANDWIDTH/2,last_left_hand_y_pos,
         last_left_hand_x_pos+HANDWIDTH/2,last_left_hand_y_pos);
    setcolor(JUG_RED);
    left_hand_pic(x_left-HANDWIDTH/2,y_left,x_left+HANDWIDTH/2,y_left);

    last_left_hand_x_pos=x_left;
    last_left_hand_y_pos=y_left;
  }
}

void move_balls_one_frame(void)
{
  int b,x_new,y_new,reflect,height,position,path,direction,point;
  int counter ;

  counter = 1 ;
  for(b=0;(b<number_of_balls) && (ball[b][1]!=0);++b)
  {
    height=ball[b][1];
    position=++ball[b][2];
    path=millsmess ? ball[b][4]:0;
    direction=ball[b][5];

    reflect=millsmess ? path<0:direction==-1;


    if(height==1)
    {
      x_new=paths[abs(path)][1][position][0];
      y_new=paths[abs(path)][1][position][1];
    }
    else
    {
      if((height==2)||(position<FRAMES))
      {
        point=(hands_position+(direction==-1)*3*FRAMES)%(6*FRAMES);
        reflect=direction==-1;
        x_new=*(movement+2*point);
        y_new=*(movement+2*point+1)-BALLSIZE;
      }
      else
      {
        x_new=paths[abs(path)][height][position-FRAMES][0];
        y_new=paths[abs(path)][height][position-FRAMES][1];
      }
    }

    if(reflect) x_new=points[0]+points[4]-x_new;

    setcolor(0);
    draw_object(old_ball[b][0],old_ball[b][1], b);
    setcolor(b+1);
    draw_object(x_new,y_new,b);

    old_ball[b][0]=x_new;
    old_ball[b][1]=y_new;
    counter++ ;
  }
}

void check_keyboard(void)
{
  char c;
  int count;
  char op ;
  int changed ;
  char new_pattern[300] ;

  changed = 0 ;
  check_for_menu_op(&changed, &op, new_pattern) ;
  if(changed >0)  
  {
    switch(op)
    {
      case 'e':exit(0) ;
               
      case 'm':{
		millsmess^=1;
		break;
	       }
      case 'c':{
		if(pattern_length!=1)
		{
		  c=pattern[0];
		  for(count=1;count<pattern_length;++count)
		   pattern[count-1]=pattern[count];
		  pattern[pattern_length-1]=c;
		}
		hands_position=0;direction=1;k=0;
		setcolor(0);
		for(count=0;count<number_of_balls;++count)
		 {
		  draw_object(old_ball[count][0],old_ball[count][1], count) ;
		  ball[count][1]=ball[count][2]=ball[count][3]=0 ;
                  ball[count][4]=ball[count][5]=0;
		 }
		restart=1;
		break;
	       }
      case 's':one_step=1;
               break;
      case 'd':{
		default_values();
		headings();
		calculate_trajectories();
		calc_hand_movements();
		break;
	       }
      case '8':{
		_3height=changed*(_3height<400);
		calculate_trajectories();
		break;
	       }
      case '2':{
		_3height=changed*(_3height>=5);
		calculate_trajectories();
		break;
	       }
      case '4':pause=changed*(changed<32767);
               break;
      case '6':pause=changed*(changed>0);
               break;
      case 'n':{
               strcpy(pattern, new_pattern) ;
               stop_juggling = 1 ;
               break ;
               }
     }
   }
}

int juggle(void)
 {
  int i,height,freeze_left,freeze_right,lflag=0,rflag=0;
  int landed_ball,to,from;
  int path,count,wait;

  hands_position=0;stop_juggling=0;one_step=0;direction=1;k=0;
  for(count=0;count<9;++count)
   ball[count][1]=ball[count][2]=ball[count][3]=ball[count][4]=ball[count][5]=0;

  clear_window() ;
  for(;;)
  {
    restart=0;
    for(i=0;i<pattern_length;++i,k=(k+1)%6)
    {
      height=pattern[i];
      if(height)
      {
	for(landed_ball=0;
            ball[landed_ball][2]!=ball[landed_ball][1]*FRAMES;
            ++landed_ball);

	from=table[direction==-1][(k+(height!=1))%6];
	to=height%2 ? table[direction!=-1][(k+height)%6]:
           table[direction==-1][(k+height)%6];
	path=height==1 ? p[from][to]:to-from;

	ball[landed_ball][1]=height;
	ball[landed_ball][2]=0;
	ball[landed_ball][4]=path;
	ball[landed_ball][5]=direction;
      }

      freeze_left=freeze_right=0;
      if(lflag)
      {
	freeze_left=1;lflag=0;
      }
      if(rflag)
      {
	freeze_right=1;rflag=0;
      }
      if(height==0)
      {
	if(direction==-1)
        {
	  freeze_left=1;lflag=1;
        }
	else
        {
	  freeze_right=1;rflag=1;
	}
      }

      for(count=0;count<FRAMES;++count)
      {
	movement=millsmess ? &mills_mess[0][0]:&normal[0][0];

	move_hands_one_frame(freeze_left,freeze_right);
        move_balls_one_frame();

	delay(pause);
	check_keyboard();
	if(stop_juggling)
          return(0);
	if(restart)
          break;
      }

      if(restart)
        break;
      direction=-direction;
     }
   }
 }

void input(char *pattern)
 {
  int c;char key;

  c=0;
  do
  {
    key=getchar();
    pattern[c]=key;
    ++c;
    if(c==300)
    {
      ++c;
      key='\n';
    }
  }
  while(key!='\n');
  pattern[--c]='\0';
  if(c==0)
   {
    pattern[0]='0';
    pattern[1]='\0';
   }
 }

int check(char *pattern)
 {
  int c,d,error=0;

  pattern_length=strlen(pattern);
  for(c=0;c<pattern_length;++c) pattern[c]=(pattern[c]-48)%10;

  for(c=0;c<pattern_length;++c)
   {
    d=(c+abs(pattern[c]))%pattern_length;
    if(pattern[d]<=0 && pattern[c]!=0)
     error=1;
    pattern[d]=-pattern[d];
   }
  for(c=0;c<pattern_length;++c)
   pattern[c]=(-pattern[c]);
  return(error);
 }



void main(int argc, char **argv)
{
  char *demo="5555555555999990000555555555567891919191919191914505555555574474474474474474494444944449444494444555555555575375726726726726726726726726751645645645645645645667717717717717713667960960960960960960990880700";

  millsmess=0;
  one_step=0;
  pause=0;
  _3height=15;
  base=250;
  /* this is modified as an extern from jug_draw.c */

  sep=40;
  switch_on_graphics(argc, argv);
  strcpy(pattern,"744");
  do_the_juggling() ;
}

void do_the_juggling(void)
{
  int i,error;

  set_up();
  for(i=0;i<9;++i)
   {
    old_ball[i][0]=old_ball[i][1]=20;
    ball[i][0]=10+i%5;
   }

  for(;;)
  {
     error=check(pattern);
     if(error)
     {
       printf("Sorry %s is not jugglable", pattern);
    
       strcpy(pattern, "612") ;
     }
    number_of_balls=0;
    for(i=0;i<pattern_length;++i)
      number_of_balls+=pattern[i];
    number_of_balls/=pattern_length;

    headings();
    juggle();
  }
}

/* new routines introduced by S.J.Limb */

void cleardevice(void) 
{
  clear_window() ;
}

void clear_window(void) 
{
  /* use your system dependent clear screen in here */
  clear_main_window() ; /* in jug_draw.c */
}

void delay(long num) 
{
  /* wait num of milliseconds */
  pause_a_bit(num) ; /* in jug_draw.c */
}

void setcolor(int colour) 
{
  /* use your system set colour here */
  set_the_colour(colour) ; /* in jug_draw.c */
}

void line(int x1, int y1, int x2, int y2) 
{
  draw_line(x1, y1, x2, y2) ; /* in jug_draw.c */
}

void do_the_resize(int new_size) 
{
  base =  new_size ;
  calculate_trajectories();
  calc_hand_movements();

}
